/*
* React Tooltip
* {@link https://github.com/ReactTooltip/react-tooltip}
* @copyright ReactTooltip Team
* @license MIT
*/
import e,{createContext as t,useState as r,useCallback as o,useMemo as l,useContext as n,useRef as i,useEffect as c,useLayoutEffect as a}from"react";import s from"classnames";import{arrow as u,computePosition as d,offset as p,flip as v,shift as m}from"@floating-ui/dom";function h(e,t){void 0===t&&(t={});var r=t.insertAt;if(e&&"undefined"!=typeof document){var o=document.head||document.getElementsByTagName("head")[0],l=document.createElement("style");l.type="text/css","top"===r&&o.firstChild?o.insertBefore(l,o.firstChild):o.appendChild(l),l.styleSheet?l.styleSheet.cssText=e:l.appendChild(document.createTextNode(e))}}h(":root{--rt-color-white:#fff;--rt-color-dark:#222;--rt-color-success:#8dc572;--rt-color-error:#be6464;--rt-color-warning:#f0ad4e;--rt-color-info:#337ab7;--rt-opacity:0.9}");const f=(e,t,r)=>{let o=null;return function(...l){const n=()=>{o=null,r||e.apply(this,l)};r&&!o&&(e.apply(this,l),o=setTimeout(n,t)),r||(o&&clearTimeout(o),o=setTimeout(n,t))}},y={anchorRefs:new Set,activeAnchor:{current:null},attach:()=>{},detach:()=>{},setActiveAnchor:()=>{}},w=t({getTooltipData:()=>y}),_=({children:t})=>{const[n,i]=r({DEFAULT_TOOLTIP_ID:new Set}),[c,a]=r({DEFAULT_TOOLTIP_ID:{current:null}}),s=(e,...t)=>{i((r=>{var o;const l=null!==(o=r[e])&&void 0!==o?o:new Set;return t.forEach((e=>l.add(e))),{...r,[e]:new Set(l)}}))},u=(e,...t)=>{i((r=>{const o=r[e];return o?(t.forEach((e=>o.delete(e))),{...r}):r}))},d=o(((e="DEFAULT_TOOLTIP_ID")=>{var t,r;return{anchorRefs:null!==(t=n[e])&&void 0!==t?t:new Set,activeAnchor:null!==(r=c[e])&&void 0!==r?r:{current:null},attach:(...t)=>s(e,...t),detach:(...t)=>u(e,...t),setActiveAnchor:t=>((e,t)=>{a((r=>{var o;return(null===(o=r[e])||void 0===o?void 0:o.current)===t.current?r:{...r,[e]:t}}))})(e,t)}}),[n,c,s,u]),p=l((()=>({getTooltipData:d})),[d]);return e.createElement(w.Provider,{value:p},t)};function b(e="DEFAULT_TOOLTIP_ID"){return n(w).getTooltipData(e)}const g=({tooltipId:t,children:r,className:o,place:l,content:n,html:a,variant:u,offset:d,wrapper:p,events:v,positionStrategy:m,delayShow:h,delayHide:f})=>{const{attach:y,detach:w}=b(t),_=i(null);return c((()=>(y(_),()=>{w(_)})),[]),e.createElement("span",{ref:_,className:s("react-tooltip-wrapper",o),"data-tooltip-place":l,"data-tooltip-content":n,"data-tooltip-html":a,"data-tooltip-variant":u,"data-tooltip-offset":d,"data-tooltip-wrapper":p,"data-tooltip-events":v,"data-tooltip-position-strategy":m,"data-tooltip-delay-show":h,"data-tooltip-delay-hide":f},r)},S="undefined"!=typeof window?a:c,A=async({elementReference:e=null,tooltipReference:t=null,tooltipArrowReference:r=null,place:o="top",offset:l=10,strategy:n="absolute",middlewares:i=[p(Number(l)),v(),m({padding:5})]})=>{if(!e)return{tooltipStyles:{},tooltipArrowStyles:{},place:o};if(null===t)return{tooltipStyles:{},tooltipArrowStyles:{},place:o};const c=i;return r?(c.push(u({element:r,padding:5})),d(e,t,{placement:o,strategy:n,middleware:c}).then((({x:e,y:t,placement:r,middlewareData:o})=>{var l,n;const i={left:`${e}px`,top:`${t}px`},{x:c,y:a}=null!==(l=o.arrow)&&void 0!==l?l:{x:0,y:0};return{tooltipStyles:i,tooltipArrowStyles:{left:null!=c?`${c}px`:"",top:null!=a?`${a}px`:"",right:"",bottom:"",[null!==(n={top:"bottom",right:"left",bottom:"top",left:"right"}[r.split("-")[0]])&&void 0!==n?n:"bottom"]:"-4px"},place:r}}))):d(e,t,{placement:"bottom",strategy:n,middleware:c}).then((({x:e,y:t,placement:r})=>({tooltipStyles:{left:`${e}px`,top:`${t}px`},tooltipArrowStyles:{},place:r})))};var E={tooltip:"styles-module_tooltip__mnnfp",fixed:"styles-module_fixed__7ciUi",arrow:"styles-module_arrow__K0L3T",noArrow:"styles-module_noArrow__T8y2L",clickable:"styles-module_clickable__Bv9o7",show:"styles-module_show__2NboJ",dark:"styles-module_dark__xNqje",light:"styles-module_light__Z6W-X",success:"styles-module_success__A2AKt",warning:"styles-module_warning__SCK0X",error:"styles-module_error__JvumD",info:"styles-module_info__BWdHW"};h(".styles-module_tooltip__mnnfp{border-radius:3px;font-size:90%;left:0;opacity:0;padding:8px 16px;pointer-events:none;position:absolute;top:0;transition:opacity .3s ease-out;visibility:hidden;width:max-content;will-change:opacity,visibility}.styles-module_fixed__7ciUi{position:fixed}.styles-module_arrow__K0L3T{background:inherit;height:8px;position:absolute;transform:rotate(45deg);width:8px}.styles-module_noArrow__T8y2L{display:none}.styles-module_clickable__Bv9o7{pointer-events:auto}.styles-module_show__2NboJ{opacity:var(--rt-opacity);visibility:visible}.styles-module_dark__xNqje{background:var(--rt-color-dark);color:var(--rt-color-white)}.styles-module_light__Z6W-X{background-color:var(--rt-color-white);color:var(--rt-color-dark)}.styles-module_success__A2AKt{background-color:var(--rt-color-success);color:var(--rt-color-white)}.styles-module_warning__SCK0X{background-color:var(--rt-color-warning);color:var(--rt-color-white)}.styles-module_error__JvumD{background-color:var(--rt-color-error);color:var(--rt-color-white)}.styles-module_info__BWdHW{background-color:var(--rt-color-info);color:var(--rt-color-white)}");const T=({id:t,className:o,classNameArrow:l,variant:n="dark",anchorId:a,anchorSelect:u,place:d="top",offset:p=10,events:v=["hover"],openOnClick:m=!1,positionStrategy:h="absolute",middlewares:y,wrapper:w,delayShow:_=0,delayHide:g=0,float:T=!1,hidden:k=!1,noArrow:O=!1,clickable:x=!1,closeOnEsc:L=!1,closeOnScroll:N=!1,closeOnResize:R=!1,style:I,position:$,afterShow:D,afterHide:C,content:H,contentWrapperRef:W,isOpen:j,setIsOpen:q,activeAnchor:z,setActiveAnchor:B})=>{const K=i(null),U=i(null),F=i(null),P=i(null),[X,J]=r(d),[M,Z]=r({}),[Y,G]=r({}),[Q,V]=r(!1),[ee,te]=r(!1),re=i(!1),oe=i(null),{anchorRefs:le,setActiveAnchor:ne}=b(t),ie=i(!1),[ce,ae]=r([]),se=i(!1),ue=m||v.includes("click");S((()=>(se.current=!0,()=>{se.current=!1})),[]),c((()=>{if(!Q){const e=setTimeout((()=>{te(!1)}),150);return()=>{clearTimeout(e)}}return()=>null}),[Q]);const de=e=>{se.current&&(e&&te(!0),setTimeout((()=>{se.current&&(null==q||q(e),void 0===j&&V(e))}),10))};c((()=>{if(void 0===j)return()=>null;j&&te(!0);const e=setTimeout((()=>{V(j)}),10);return()=>{clearTimeout(e)}}),[j]),c((()=>{Q!==re.current&&(re.current=Q,Q?null==D||D():null==C||C())}),[Q]);const pe=(e=g)=>{P.current&&clearTimeout(P.current),P.current=setTimeout((()=>{ie.current||de(!1)}),e)},ve=e=>{var t;if(!e)return;const r=null!==(t=e.currentTarget)&&void 0!==t?t:e.target;if(!(null==r?void 0:r.isConnected))return B(null),void ne({current:null});_?(F.current&&clearTimeout(F.current),F.current=setTimeout((()=>{de(!0)}),_)):de(!0),B(r),ne({current:r}),P.current&&clearTimeout(P.current)},me=()=>{x?pe(g||100):g?pe():de(!1),F.current&&clearTimeout(F.current)},he=({x:e,y:t})=>{A({place:d,offset:p,elementReference:{getBoundingClientRect:()=>({x:e,y:t,width:0,height:0,top:t,left:e,right:e,bottom:t})},tooltipReference:K.current,tooltipArrowReference:U.current,strategy:h,middlewares:y}).then((e=>{Object.keys(e.tooltipStyles).length&&Z(e.tooltipStyles),Object.keys(e.tooltipArrowStyles).length&&G(e.tooltipArrowStyles),J(e.place)}))},fe=e=>{if(!e)return;const t=e,r={x:t.clientX,y:t.clientY};he(r),oe.current=r},ye=e=>{ve(e),g&&pe()},we=e=>{var t;[document.querySelector(`[id='${a}']`),...ce].some((t=>null==t?void 0:t.contains(e.target)))||(null===(t=K.current)||void 0===t?void 0:t.contains(e.target))||de(!1)},_e=e=>{"Escape"===e.key&&de(!1)},be=f(ve,50,!0),ge=f(me,50,!0);c((()=>{var e,t;const r=new Set(le);ce.forEach((e=>{r.add({current:e})}));const o=document.querySelector(`[id='${a}']`);o&&r.add({current:o}),N&&window.addEventListener("scroll",ge),R&&window.addEventListener("resize",ge),L&&window.addEventListener("keydown",_e);const l=[];ue?(window.addEventListener("click",we),l.push({event:"click",listener:ye})):(l.push({event:"mouseenter",listener:be},{event:"mouseleave",listener:ge},{event:"focus",listener:be},{event:"blur",listener:ge}),T&&l.push({event:"mousemove",listener:fe}));const n=()=>{ie.current=!0},i=()=>{ie.current=!1,me()};return x&&!ue&&(null===(e=K.current)||void 0===e||e.addEventListener("mouseenter",n),null===(t=K.current)||void 0===t||t.addEventListener("mouseleave",i)),l.forEach((({event:e,listener:t})=>{r.forEach((r=>{var o;null===(o=r.current)||void 0===o||o.addEventListener(e,t)}))})),()=>{var e,t;N&&window.removeEventListener("scroll",ge),R&&window.removeEventListener("resize",ge),ue&&window.removeEventListener("click",we),L&&window.removeEventListener("keydown",_e),x&&!ue&&(null===(e=K.current)||void 0===e||e.removeEventListener("mouseenter",n),null===(t=K.current)||void 0===t||t.removeEventListener("mouseleave",i)),l.forEach((({event:e,listener:t})=>{r.forEach((r=>{var o;null===(o=r.current)||void 0===o||o.removeEventListener(e,t)}))}))}}),[ee,le,ce,L,v]),c((()=>{let e=null!=u?u:"";!e&&t&&(e=`[data-tooltip-id='${t}']`);const r=new MutationObserver((r=>{const o=[];r.forEach((r=>{if("attributes"===r.type&&"data-tooltip-id"===r.attributeName){r.target.getAttribute("data-tooltip-id")===t&&o.push(r.target)}if("childList"===r.type&&(z&&[...r.removedNodes].some((e=>{var t;return!!(null===(t=null==e?void 0:e.contains)||void 0===t?void 0:t.call(e,z))&&(te(!1),de(!1),B(null),!0)})),e))try{const t=[...r.addedNodes].filter((e=>1===e.nodeType));o.push(...t.filter((t=>t.matches(e)))),o.push(...t.flatMap((t=>[...t.querySelectorAll(e)])))}catch(e){}})),o.length&&ae((e=>[...e,...o]))}));return r.observe(document.body,{childList:!0,subtree:!0,attributes:!0,attributeFilter:["data-tooltip-id"]}),()=>{r.disconnect()}}),[t,u,z]);const Se=()=>{$?he($):T?oe.current&&he(oe.current):A({place:d,offset:p,elementReference:z,tooltipReference:K.current,tooltipArrowReference:U.current,strategy:h,middlewares:y}).then((e=>{se.current&&(Object.keys(e.tooltipStyles).length&&Z(e.tooltipStyles),Object.keys(e.tooltipArrowStyles).length&&G(e.tooltipArrowStyles),J(e.place))}))};c((()=>{Se()}),[Q,z,H,I,d,p,h,$]),c((()=>{if(!(null==W?void 0:W.current))return()=>null;const e=new ResizeObserver((()=>{Se()}));return e.observe(W.current),()=>{e.disconnect()}}),[H,null==W?void 0:W.current]),c((()=>{var e;const t=document.querySelector(`[id='${a}']`),r=[...ce,t];z&&r.includes(z)||B(null!==(e=ce[0])&&void 0!==e?e:t)}),[a,ce,z]),c((()=>()=>{F.current&&clearTimeout(F.current),P.current&&clearTimeout(P.current)}),[]),c((()=>{let e=u;if(!e&&t&&(e=`[data-tooltip-id='${t}']`),e)try{const t=Array.from(document.querySelectorAll(e));ae(t)}catch(e){ae([])}}),[t,u]);const Ae=!k&&H&&Q&&Object.keys(M).length>0;return ee?e.createElement(w,{id:t,role:"tooltip",className:s("react-tooltip",E.tooltip,E[n],o,`react-tooltip__place-${X}`,{[E.show]:Ae,[E.fixed]:"fixed"===h,[E.clickable]:x}),style:{...I,...M},ref:K},H,e.createElement(w,{className:s("react-tooltip-arrow",E.arrow,l,{[E.noArrow]:O}),style:Y,ref:U})):null},k=({content:t})=>e.createElement("span",{dangerouslySetInnerHTML:{__html:t}}),O=({id:t,anchorId:o,anchorSelect:l,content:n,html:a,render:s,className:u,classNameArrow:d,variant:p="dark",place:v="top",offset:m=10,wrapper:h="div",children:f=null,events:y=["hover"],openOnClick:w=!1,positionStrategy:_="absolute",middlewares:g,delayShow:S=0,delayHide:A=0,float:E=!1,hidden:O=!1,noArrow:x=!1,clickable:L=!1,closeOnEsc:N=!1,closeOnScroll:R=!1,closeOnResize:I=!1,style:$,position:D,isOpen:C,setIsOpen:H,afterShow:W,afterHide:j})=>{const[q,z]=r(n),[B,K]=r(a),[U,F]=r(v),[P,X]=r(p),[J,M]=r(m),[Z,Y]=r(S),[G,Q]=r(A),[V,ee]=r(E),[te,re]=r(O),[oe,le]=r(h),[ne,ie]=r(y),[ce,ae]=r(_),[se,ue]=r(null),{anchorRefs:de,activeAnchor:pe}=b(t),ve=e=>null==e?void 0:e.getAttributeNames().reduce(((t,r)=>{var o;if(r.startsWith("data-tooltip-")){t[r.replace(/^data-tooltip-/,"")]=null!==(o=null==e?void 0:e.getAttribute(r))&&void 0!==o?o:null}return t}),{}),me=e=>{const t={place:e=>{var t;F(null!==(t=e)&&void 0!==t?t:v)},content:e=>{z(null!=e?e:n)},html:e=>{K(null!=e?e:a)},variant:e=>{var t;X(null!==(t=e)&&void 0!==t?t:p)},offset:e=>{M(null===e?m:Number(e))},wrapper:e=>{var t;le(null!==(t=e)&&void 0!==t?t:h)},events:e=>{const t=null==e?void 0:e.split(" ");ie(null!=t?t:y)},"position-strategy":e=>{var t;ae(null!==(t=e)&&void 0!==t?t:_)},"delay-show":e=>{Y(null===e?S:Number(e))},"delay-hide":e=>{Q(null===e?A:Number(e))},float:e=>{ee(null===e?E:"true"===e)},hidden:e=>{re(null===e?O:"true"===e)}};Object.values(t).forEach((e=>e(null))),Object.entries(e).forEach((([e,r])=>{var o;null===(o=t[e])||void 0===o||o.call(t,r)}))};c((()=>{z(n)}),[n]),c((()=>{K(a)}),[a]),c((()=>{F(v)}),[v]),c((()=>{X(p)}),[p]),c((()=>{M(m)}),[m]),c((()=>{Y(S)}),[S]),c((()=>{Q(A)}),[A]),c((()=>{ee(E)}),[E]),c((()=>{re(O)}),[O]),c((()=>{ae(_)}),[_]),c((()=>{var e;const r=new Set(de);let n=l;if(!n&&t&&(n=`[data-tooltip-id='${t}']`),n)try{document.querySelectorAll(n).forEach((e=>{r.add({current:e})}))}catch(e){console.warn(`[react-tooltip] "${n}" is not a valid CSS selector`)}const i=document.querySelector(`[id='${o}']`);if(i&&r.add({current:i}),!r.size)return()=>null;const c=null!==(e=null!=se?se:i)&&void 0!==e?e:pe.current,a=new MutationObserver((e=>{e.forEach((e=>{var t;if(!c||"attributes"!==e.type||!(null===(t=e.attributeName)||void 0===t?void 0:t.startsWith("data-tooltip-")))return;const r=ve(c);me(r)}))})),s={attributes:!0,childList:!1,subtree:!1};if(c){const e=ve(c);me(e),a.observe(c,s)}return()=>{a.disconnect()}}),[de,pe,se,o,l]);let he=f;const fe=i(null);if(s){const t=s({content:null!=q?q:null,activeAnchor:se});he=t?e.createElement("div",{ref:fe,className:"react-tooltip-content-wrapper"},t):null}else q&&(he=q);B&&(he=e.createElement(k,{content:B}));const ye={id:t,anchorId:o,anchorSelect:l,className:u,classNameArrow:d,content:he,contentWrapperRef:fe,place:U,variant:P,offset:J,wrapper:oe,events:ne,openOnClick:w,positionStrategy:ce,middlewares:g,delayShow:Z,delayHide:G,float:V,hidden:te,noArrow:x,clickable:L,closeOnEsc:N,closeOnScroll:R,closeOnResize:I,style:$,position:D,isOpen:C,setIsOpen:H,afterShow:W,afterHide:j,activeAnchor:se,setActiveAnchor:e=>ue(e)};return e.createElement(T,{...ye})};export{O as Tooltip,_ as TooltipProvider,g as TooltipWrapper};
//# sourceMappingURL=react-tooltip.min.mjs.map
